Codeforces Round #367 (Div. 2) A , B , C

A. Beru-taxi
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy lives at point (a, b) of the coordinate plane. He is hurrying up to work so he wants to get out of his house as soon as possible. New app suggested n available Beru-taxi nearby. The i-th taxi is located at point (xi, yi) and moves with a speed vi.

Consider that each of n drivers will move directly to Vasiliy and with a maximum possible speed. Compute the minimum time when Vasiliy will get in any of Beru-taxi cars.

Input

The first line of the input contains two integers a and b ( - 100 ≤ a, b ≤ 100) — coordinates of Vasiliy's home.

The second line contains a single integer n (1 ≤ n ≤ 1000) — the number of available Beru-taxi cars nearby.

The i-th of the following n lines contains three integers xi, yi and vi ( - 100 ≤ xi, yi ≤ 100, 1 ≤ vi ≤ 100) — the coordinates of the i-th car and its speed.

It's allowed that several cars are located at the same point. Also, cars may be located at exactly the same point where Vasiliy lives.

Output

Print a single real value — the minimum time Vasiliy needs to get in any of the Beru-taxi cars. You answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Namely: let's assume that your answer is a, and the answer of the jury is b. The checker program will consider your answer correct, if .

Examples
Input
0 0
2
2 0 1
0 2 2
Output
1.00000000000000000000
Input
1 3
3
3 3 2
-2 3 6
-2 7 10
Output
0.50000000000000000000
Note

In the first sample, first taxi will get to Vasiliy in time 2, and second will do this in time 1, therefore 1 is the answer.

In the second sample, cars 2 and 3 will arrive simultaneously.

题意:给你一个你当前的位置(a,b),给你n个出租车的位置和速度(xi,yi,vi),求某个出租车到你的最短时间;

思路:直接暴力就是;

#include<bits/stdc++.h>
using namespace std;
#define ll __int64
#define esp 1e-10
const int N=3e5+10,M=1e6+10,mod=1e9+7,inf=1e9+10;
double jilu(double a,double b,double c,double d)
{
    return sqrt((d-b)*(d-b)+(c-a)*(c-a));
}
int main()
{
    int x,y,z,i,t;
    double a,b;
    scanf("%lf%lf",&a,&b);
    scanf("%d",&x);
    double ans=1000000000.0;
    while(x--)
    {
        double xi,yi,vi;
        scanf("%lf%lf%lf",&xi,&yi,&vi);
        ans=min(ans,jilu(xi,yi,a,b)/vi);
    }
    printf("%f
",ans);
    return 0;
}
B. Interesting drink
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy likes to rest after a hard work, so you may often meet him in some bar nearby. As all programmers do, he loves the famous drink "Beecola", which can be bought in n different shops in the city. It's known that the price of one bottle in the shop i is equal to xi coins.

Vasiliy plans to buy his favorite drink for q consecutive days. He knows, that on the i-th day he will be able to spent mi coins. Now, for each of the days he want to know in how many different shops he can buy a bottle of "Beecola".

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 100 000) — the number of shops in the city that sell Vasiliy's favourite drink.

The second line contains n integers xi (1 ≤ xi ≤ 100 000) — prices of the bottles of the drink in the i-th shop.

The third line contains a single integer q (1 ≤ q ≤ 100 000) — the number of days Vasiliy plans to buy the drink.

Then follow q lines each containing one integer mi (1 ≤ mi ≤ 109) — the number of coins Vasiliy can spent on the i-th day.

Output

Print q integers. The i-th of them should be equal to the number of shops where Vasiliy will be able to buy a bottle of the drink on the i-th day.

Example
Input
5
3 10 8 6 11
4
1
10
3
11
Output
0
4
1
5
Note

On the first day, Vasiliy won't be able to buy a drink in any of the shops.

On the second day, Vasiliy can buy a drink in the shops 1, 2, 3 and 4.

On the third day, Vasiliy can buy a drink only in the shop number 1.

Finally, on the last day Vasiliy can buy a drink in any shop.

题意:给你一个数组,q个询问,求小于等于mi的数的个数;

思路:二分查找;

#include<bits/stdc++.h>
using namespace std;
#define ll __int64
#define esp 1e-10
const int N=3e5+10,M=1e6+10,mod=1e9+7,inf=1e9+10;
int a[N];
int main()
{
    int x,y,z,i,t;
    scanf("%d",&x);
    for(i=0;i<x;i++)
    scanf("%d",&a[i]);
    sort(a,a+x);
    scanf("%d",&y);
    while(y--)
    {
        scanf("%d",&z);
        int pos=upper_bound(a,a+x,z)-a;
        printf("%d
",pos);
    }
    return 0;
}
C. Hard problem
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vasiliy is fond of solving different tasks. Today he found one he wasn't able to solve himself, so he asks you to help.

Vasiliy is given n strings consisting of lowercase English letters. He wants them to be sorted in lexicographical order (as in the dictionary), but he is not allowed to swap any of them. The only operation he is allowed to do is to reverse any of them (first character becomes last, second becomes one before last and so on).

To reverse the i-th string Vasiliy has to spent ci units of energy. He is interested in the minimum amount of energy he has to spent in order to have strings sorted in lexicographical order.

String A is lexicographically smaller than string B if it is shorter than B (|A| < |B|) and is its prefix, or if none of them is a prefix of the other and at the first position where they differ character in A is smaller than the character in B.

For the purpose of this problem, two equal strings nearby do not break the condition of sequence being sorted lexicographically.

Input

The first line of the input contains a single integer n (2 ≤ n ≤ 100 000) — the number of strings.

The second line contains n integers ci (0 ≤ ci ≤ 109), the i-th of them is equal to the amount of energy Vasiliy has to spent in order to reverse the i-th string.

Then follow n lines, each containing a string consisting of lowercase English letters. The total length of these strings doesn't exceed 100 000.

Output

If it is impossible to reverse some of the strings such that they will be located in lexicographical order, print  - 1. Otherwise, print the minimum total amount of energy Vasiliy has to spent.

Examples
Input
2
1 2
ba
ac
Output
1
Input
3
1 3 1
aa
ba
ac
Output
1
Input
2
5 5
bbb
aaa
Output
-1
Input
2
3 3
aaa
aa
Output
-1
Note

In the second sample one has to reverse string 2 or string 3. To amount of energy required to reverse the string 3 is smaller.

In the third sample, both strings do not change after reverse and they go in the wrong order, so the answer is  - 1.

In the fourth sample, both strings consists of characters 'a' only, but in the sorted order string "aa" should go before string "aaa", thus the answer is  - 1.

题意:n个字符串,第i个字符串要翻转需要花费a[i],使得最后的字符串成字典序排列,求最小花费,始终不行输出-1;

思路:dp,dp[i][0]表示第i个字符串不翻转成字典序排列的花费,dp[i][1]表示第i个字符串翻转成字典序排列的花费;

#include<bits/stdc++.h>
using namespace std;
#define ll __int64
#define mod 1000000007
#define pi (4*atan(1.0))
const int N=1e5+10,M=2e6+10,inf=1e9+10;
const ll INF=1e17;
ll dp[N][3];
string str1[N];
string str2[N];
ll a[N];
void init()
{
    for(int i=1;i<N;i++)
    dp[i][0]=dp[i][1]=INF;
}
int main()
{
    int x,y,z,i,t;
    init();
    scanf("%d",&x);
    for(i=1;i<=x;i++)
    scanf("%I64d",&a[i]);
    for(i=1;i<=x;i++)
    {
        cin>>str1[i];
        str2[i]=str1[i];
        reverse(str2[i].begin(),str2[i].end());
    }
    dp[1][0]=0;
    dp[1][1]=a[1];
    for(i=2;i<=x;i++)
    {
        if(str1[i]>=str1[i-1])
        dp[i][0]=min(dp[i][0],dp[i-1][0]);
        if(str1[i]>=str2[i-1])
        dp[i][0]=min(dp[i][0],dp[i-1][1]);
        if(str2[i]>=str1[i-1])
        dp[i][1]=min(dp[i][1],dp[i-1][0]+a[i]);
        if(str2[i]>=str2[i-1])
        dp[i][1]=min(dp[i][1],dp[i-1][1]+a[i]);
    }
    ll ans=min(dp[x][0],dp[x][1]);
    if(ans<INF)
    printf("%I64d
",ans);
    else
    printf("-1
");
    return 0;
}
原文地址:https://www.cnblogs.com/jhz033/p/5763778.html